import org.teiid.language.QueryExpression;
import org.teiid.metadata.MetadataFactory;
import org.teiid.metadata.RuntimeMetadata;
import org.teiid.metadata.Table;
import org.teiid.translator.ExecutionContext;
import org.teiid.translator.ExecutionFactory;
import org.teiid.translator.ResultSetExecution;
import org.teiid.translator.TranslatorException;
import org.teiid.translator.TypeFacility;

public class CountingExecutionFactory
    extends ExecutionFactory<Void, Void>
{
    public CountingExecutionFactory()
    {
        setSourceRequired(false);
        setSourceRequiredForMetadata(false);
    }

    @Override
    public void getMetadata(final MetadataFactory metadataFactory,
                            final Void conn) throws TranslatorException
    {
        final Table table = metadataFactory.addTable("t");
        metadataFactory.addColumn("c", TypeFacility.RUNTIME_NAMES.STRING, table);
    }

    @Override
    public ResultSetExecution createResultSetExecution(final QueryExpression command,
                                                       final ExecutionContext executionContext,
                                                       final RuntimeMetadata metadata,
                                                       final Void connection) throws TranslatorException
    {
        return new CountingExecution();
    }
}
